#include "bits/stdc++.h"
#include "testlib.h"
#define puba push_back
#define mapa make_pair
#define ff first
#define ss second
#define bend(_x) begin(_x), end(_x)
#define szof(_x) ((int) (_x).size())

using namespace std;
typedef long long ll;
typedef pair<int, int> pii;
const int MAXN = 505;

vector<pair<int, char>> graph[MAXN];
bool marked[MAXN];
int in[MAXN], out[MAXN];
int depth[MAXN];
int parent[MAXN];
char symb[MAXN];
int tcnt;

int dfs(int v, int d) {
    depth[v] = d;
    in[v] = tcnt++;
    for (auto to : graph[v]) {
        parent[to.ff] = v;
        symb[to.ff] = to.ss;
        dfs(to.ff, d + 1);
    }
    out[v] = tcnt;
    return 0;
}

int main(int argc, char * argv[]) {
    registerTestlibCmd(argc, argv);
    
    int n = inf.readInt();
    int m = inf.readInt();
    int t = inf.readInt();

    for (int i = 0; i < n - 1; ++i) {
        int p = inf.readInt();
        inf.readSpace();
        char c = inf.readChar();
        graph[p - 1].puba({i + 1, c});
    }

    dfs(0, 0);

    vector<pair<int, string>> words;
    for (int i = 0; i < m; ++i) {
        int w = inf.readInt();
        string s = inf.readToken();
        words.puba({w, s});
    }

    ll pans = ouf.readLong();
    ll jans = ans.readLong();
    if (!t) {
        if (pans == jans) {
            quitf(_ok, "%lld", jans);
        }
        quitf(_wa, "expected %lld, found %lld", jans, pans);
    }

    if (pans != jans) {
        if (pans == -1) {
            quitf(_wa, "jury have solution but participant don't have one");
        } else {
            if (jans != -1) {
                if (jans < pans) {
                    quitf(_wa, "jury have better solution than participant");
                }
            }
        }
    }
    if (pans == -1 && jans == -1) {
        quitf(_ok, "solution doesn't exist");
    }
    if (pans != -1) {
        int sz = ouf.readInt();
        if (sz < 0) {
            quitf(_wa, "number of strings is negative");
        }
        ll totw = 0;
        for (int i = 0; i < sz; ++i) {
            int a = ouf.readInt(1, n) - 1, b = ouf.readInt(1, n) - 1, c = ouf.readInt(1, m) - 1;
            if (!(in[a] <= in[b] && out[b] <= out[a])) {
                quitf(_wa, "%d isn't ancestor of %d", a + 1, b + 1);
            }
            if (depth[b] - depth[a] != szof(words[c].ss)) {
                quitf(_wa, "length of path from %d to %d isn't equal to length of word #%d", a + 1, b + 1, c + 1);
            }
            int v = b;
            string cur = "";
            while (v != a) {
                cur += symb[v];
                marked[v] = true;
                v = parent[v];
            }
            reverse(bend(cur));
            if (cur != words[c].ss) {
                quitf(_wa, "string on path from %d to %d isn't equal to word #%d", a + 1, b + 1, c + 1);
            }
            totw += words[c].ff;
        }
        for (int i = 1; i < n; ++i) {
            if (!marked[i]) {
                quitf(_wa, "edge from %d to %d isn't covered", parent[i] + 1, i + 1);
            }
        }
        if (totw != pans) {
            quitf(_wa, "cost of solution isn't equal to number printed by participant");
        }
    }

    if (jans == -1 || pans < jans) {
        quitf(_fail, "participant found solution but jury didn't");
    }

    quitf(_ok, "solution is correct");

    return 0;
}