//
// Written by Sayutin Dmitry
//

#include <iostream>
#include <vector>
#include <stdint.h>
#include <algorithm>
#include <set>
#include <map>
#include <array>
#include <queue>
#include <stack>
#include <functional>
#include <utility>
#include <string>
#include <assert.h>
#include <iterator>
#include <cstdint>
#include <cinttypes>
#include <string.h>
#include <random>
#include <numeric>
#include <tuple>

using std::cin;
using std::cout;
using std::cerr;

using std::vector;
using std::map;
using std::array;
using std::set;
using std::string;

using std::pair;
using std::make_pair;

using std::min;
using std::abs;
using std::max;

using std::unique;
using std::sort;
using std::generate;
using std::reverse;
using std::min_element;
using std::max_element;

#ifdef LOCAL
#define LASSERT(X) assert(X)
#else
#define LASSERT(X) {}
#endif

template <typename T>
T input() {
    T res;
    cin >> res;
    LASSERT(cin);
    return res;
}

template <typename IT>
void input_seq(IT b, IT e) {
    std::generate(b, e, input<typename std::remove_reference<decltype(*b)>::type>);
}

#define SZ(vec)         int((vec).size())
#define ALL(data)       data.begin(),data.end()
#define RALL(data)      data.rbegin(),data.rend()
#define TYPEMAX(type)   std::numeric_limits<type>::max()
#define TYPEMIN(type)   std::numeric_limits<type>::min()

#define pb push_back
#define eb emplace_back

pair<int, int> get_dp(const vector<vector<int>>& graph, int v) {
    int dep = 0;
    int diam = 0;
    vector<int> best;
    for (int u: graph[v]) {
        pair<int, int> sub = get_dp(graph, u);
        
        dep  = max(dep, 1 + sub.first);
        diam = max(diam, sub.second);
        
        best.push_back(sub.first + 1);
    }

    if (best.size() == 1)
        diam = max(diam, best[0]);
    else if (best.size() >= 2) {
        std::nth_element(best.begin(), best.begin() + best.size() - 2, best.end());
        diam = max(diam, best[best.size() - 2] + best.back());
    }

    return {dep, diam};
}

int main() {
    std::iostream::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    
    // code here.
    int n = input<int>();
    int m = input<int>();

    vector<vector<int>> graph(n);
    for (int i = 2; i <= n; ++i) {
        int p = input<int>() - 1;
        graph[p].pb(i - 1);
    }

    pair<int, int> dp = get_dp(graph, 0);

    cout << 1 + dp.second + (1 + dp.first) * int64_t(2 * m - 2) << "\n";
    
    return 0;
}
