//
// Written by Sayutin Dmitry
//

#include <iostream>
#include <vector>
#include <stdint.h>
#include <algorithm>
#include <set>
#include <map>
#include <array>
#include <queue>
#include <stack>
#include <functional>
#include <utility>
#include <string>
#include <assert.h>
#include <iterator>
#include <cstdint>
#include <cinttypes>
#include <string.h>
#include <random>
#include <numeric>
#include <tuple>

using std::cin;
using std::cout;
using std::cerr;

using std::vector;
using std::map;
using std::array;
using std::set;
using std::string;

using std::pair;
using std::make_pair;

using std::min;
using std::abs;
using std::max;

using std::unique;
using std::sort;
using std::generate;
using std::reverse;
using std::min_element;
using std::max_element;

#ifdef LOCAL
#define LASSERT(X) assert(X)
#else
#define LASSERT(X) {}
#endif

template <typename T>
T input() {
    T res;
    cin >> res;
    LASSERT(cin);
    return res;
}

template <typename IT>
void input_seq(IT b, IT e) {
    std::generate(b, e, input<typename std::remove_reference<decltype(*b)>::type>);
}

#define SZ(vec)         int((vec).size())
#define ALL(data)       data.begin(),data.end()
#define RALL(data)      data.rbegin(),data.rend()
#define TYPEMAX(type)   std::numeric_limits<type>::max()
#define TYPEMIN(type)   std::numeric_limits<type>::min()

#define pb push_back
#define eb emplace_back

void calc_dp(const vector<vector<int>>& graph, pair<int64_t, int64_t> old_root, vector<pair<int64_t, int64_t>>& nw, int v) {
    nw[v] = {0, 0};

    int64_t b0 = 0, b1 = 0;
    auto process = [&b0, &b1](int64_t nw) {
        if (nw >= b1)
            b0 = b1, b1 = nw;
        else if (nw >= b0)
            b0 = nw;
    };

    if (graph[v].empty() and old_root.first >= 0) {
        nw[v].first  = max(nw[v].first,  1 + old_root.first);
        nw[v].second = max(nw[v].second, old_root.second);
        process(old_root.first + 1);
    }

    for (int u: graph[v]) {
        calc_dp(graph, old_root, nw, u);
        nw[v].first  = max(nw[v].first,  1 + nw[u].first);
        nw[v].second = max(nw[v].second, nw[u].second);
        process(nw[u].first + 1);
    }

    nw[v].second = max(nw[v].second, b0 + b1);
}

int main() {
    std::iostream::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    
    // code here.
    int n = input<int>();
    int m = input<int>();

    vector<vector<int>> graph(n);
    for (int i = 2; i <= n; ++i) {
        int p = input<int>() - 1;
        graph[p].pb(i - 1);
    }
    
    pair<int64_t, int64_t> old_root = {-100, -100};
    for (int i = 0; i != m; ++i) {
        vector<pair<int64_t, int64_t>> nw(n, {-100, -100});

        calc_dp(graph, old_root, nw, 0);

        old_root = nw[0];
    }

    cout << 1 + old_root.second << "\n";
    
    return 0;
}
