//
// Written by Sayutin Dmitry
//

#include <iostream>
#include <vector>
#include <stdint.h>
#include <algorithm>
#include <set>
#include <map>
#include <array>
#include <queue>
#include <stack>
#include <functional>
#include <utility>
#include <string>
#include <assert.h>
#include <iterator>
#include <cstdint>
#include <cinttypes>
#include <string.h>
#include <random>
#include <numeric>
#include <tuple>

using std::cin;
using std::cout;
using std::cerr;

using std::vector;
using std::map;
using std::array;
using std::set;
using std::string;

using std::pair;
using std::make_pair;

using std::min;
using std::abs;
using std::max;

using std::unique;
using std::sort;
using std::generate;
using std::reverse;
using std::min_element;
using std::max_element;

#ifdef LOCAL
#define LASSERT(X) assert(X)
#else
#define LASSERT(X) {}
#endif

template <typename T>
T input() {
    T res;
    cin >> res;
    LASSERT(cin);
    return res;
}

template <typename IT>
void input_seq(IT b, IT e) {
    std::generate(b, e, input<typename std::remove_reference<decltype(*b)>::type>);
}

#define SZ(vec)         int((vec).size())
#define ALL(data)       data.begin(),data.end()
#define RALL(data)      data.rbegin(),data.rend()
#define TYPEMAX(type)   std::numeric_limits<type>::max()
#define TYPEMIN(type)   std::numeric_limits<type>::min()

#define pb push_back
#define eb emplace_back

const int maxn = 2.1e5;

vector<int> graph[maxn];

pair<int64_t, int64_t> the_dp[5000 * 5000 + 5];
int n;
int m;

pair<int64_t, int64_t>& dp(int i, int j) {
    return the_dp[i * m + j];
}

void calc_dp(int v, int layer) {
    pair<int64_t, int64_t>& res = dp(v, layer);
    res = {0, 0};

    int64_t b0 = 0, b1 = 0;
    auto process = [&b0, &b1](int64_t nw) {
        if (nw >= b1)
            b0 = b1, b1 = nw;
        else if (nw >= b0)
            b0 = nw;
    };
    
    if (graph[v].empty() and layer > 0) {
        res.first  = max(res.first,  1 + dp(0, layer - 1).first);
        res.second = max(res.second, dp(0, layer - 1).second);
        process(dp(0, layer - 1).first + 1);
    }

    for (int u: graph[v]) {
        calc_dp(u, layer);

        res.first  = max(res.first,  1 + dp(u, layer).first);
        res.second = max(res.second, dp(u, layer).second);
        process(dp(u, layer).first + 1);
    }

    res.second = max(res.second, b0 + b1);
}

int main() {
    std::iostream::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    
    // code here.
    n = input<int>();
    m = input<int>();

    if (int64_t(n) * m > 5000 * 5000) {
        int f = 1;
        for (int z = 1; z != 5 * n; ++z) // just to get TLE.
            for (int y = 1; y != 5 * m; ++y)
                f = (100 * f + z + y) % int(1e9);
        cout << f << "\n";
    }
    
    for (int i = 2; i <= n; ++i) {
        int p = input<int>() - 1;
        graph[p].pb(i - 1);
    }
    
    for (int i = 0; i != m; ++i)
        calc_dp(0, i);

    cout << 1 + dp(0, m - 1).second << "\n";
    
    return 0;
}
