//
// Written by Sayutin Dmitry
//

#include <iostream>
#include <vector>
#include <stdint.h>
#include <algorithm>
#include <set>
#include <map>
#include <array>
#include <queue>
#include <stack>
#include <functional>
#include <utility>
#include <string>
#include <assert.h>
#include <iterator>
#include <cstdint>
#include <cinttypes>
#include <string.h>
#include <random>
#include <numeric>
#include <tuple>

using std::cin;
using std::cout;
using std::cerr;

using std::vector;
using std::map;
using std::array;
using std::set;
using std::string;

using std::pair;
using std::make_pair;

using std::min;
using std::abs;
using std::max;

using std::unique;
using std::sort;
using std::generate;
using std::reverse;
using std::min_element;
using std::max_element;

#ifdef LOCAL
#define LASSERT(X) assert(X)
#else
#define LASSERT(X) {}
#endif

template <typename T>
T input() {
    T res;
    cin >> res;
    LASSERT(cin);
    return res;
}

template <typename IT>
void input_seq(IT b, IT e) {
    std::generate(b, e, input<typename std::remove_reference<decltype(*b)>::type>);
}

#define SZ(vec)         int((vec).size())
#define ALL(data)       data.begin(),data.end()
#define RALL(data)      data.rbegin(),data.rend()
#define TYPEMAX(type)   std::numeric_limits<type>::max()
#define TYPEMIN(type)   std::numeric_limits<type>::min()

#define pb push_back
#define eb emplace_back

const int maxn = 2.1e5;

vector<int> graph[maxn];

pair<int64_t, int64_t> calc_dp(pair<int64_t, int64_t> old_root, int v) {
    pair<int64_t, int64_t> res = {0, 0};

    int64_t b0 = 0, b1 = 0;
    auto process = [&b0, &b1](int64_t nw) {
        if (nw >= b1)
            b0 = b1, b1 = nw;
        else if (nw >= b0)
            b0 = nw;
    };
    
    if (graph[v].empty() and old_root.first >= 0) {
        res.first  = max(res.first,  1 + old_root.first);
        res.second = max(res.second, old_root.second);
        process(old_root.first + 1);
    }

    for (int u: graph[v]) {
        auto ch = calc_dp(old_root, u);
        res.first  = max(res.first,  1 + ch.first);
        res.second = max(res.second, ch.second);
        process(ch.first + 1);
    }

    res.second = max(res.second, b0 + b1);
    
    return res;
}

int main() {
    std::iostream::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    
    // code here.
    int n = input<int>();
    int m = input<int>();
    
    for (int i = 2; i <= n; ++i) {
        int p = input<int>() - 1;
        graph[p].pb(i - 1);
    }
    
    pair<int64_t, int64_t> old_root = {-100, -100};
    for (int i = 0; i != m; ++i)
        old_root = calc_dp(old_root, 0);

    cout << 1 + old_root.second << "\n";
    
    return 0;
}
