#include <iostream>
#include <vector>
#include <stdint.h>
#include <algorithm>
#include <set>
#include <map>
#include <array>
#include <queue>
#include <stack>
#include <functional>
#include <utility>
#include <string>
#include <assert.h>
#include <iterator>
#include <cstdint>
#include <cinttypes>
#include <string.h>
#include <random>
#include <numeric>
#include <tuple>
#include <unordered_map>

using std::cin;
using std::cout;
using std::cerr;

using std::vector;
using std::map;
using std::array;
using std::set;
using std::string;

using std::pair;
using std::make_pair;

using std::min;
using std::abs;
using std::max;

using std::unique;
using std::sort;
using std::generate;
using std::reverse;
using std::min_element;
using std::max_element;

using std::unordered_map;

#ifdef LOCAL
#define LASSERT(X) assert(X)
#else
#define LASSERT(X) {}
#endif

template <typename T>
T input() {
    T res;
    cin >> res;
    LASSERT(cin);
    return res;
}

template <typename IT>
void input_seq(IT b, IT e) {
    std::generate(b, e, input<typename std::remove_reference<decltype(*b)>::type>);
}

#define SZ(vec)         int((vec).size())
#define ALL(data)       data.begin(),data.end()
#define RALL(data)      data.rbegin(),data.rend()
#define TYPEMAX(type)   std::numeric_limits<type>::max()
#define TYPEMIN(type)   std::numeric_limits<type>::min()

#define pb push_back
#define eb emplace_back

#ifdef LOCAL
#define STAMP(MSG) {fprintf(stderr, "%.2lf: %s\n", double(clock()) / CLOCKS_PER_SEC, MSG);}
#else
#define STAMP(MSG)
#endif

unordered_map<int, int> color;

void init(int node, int nl, int nr, int l, int r, int col) {
    if (r <= nl or nr <= l)
        return;
    
    if (l <= nl and nr <= r)
        color[node] = col;
    else {
        int mi = nl + (nr - nl) / 2;
        init(2 * node + 1, nl, mi, l, r, col);
        init(2 * node + 2, mi, nr, l, r, col);
    }
}

vector<pair<int, int>> count(int node, int nl, int nr) {
    if (color.count(node)) {
        vector<pair<int, int>> res = {
            {0, 1},
            {color[node], 0}
        };
        
        return res;
    } else {
        int mi = nl + (nr - nl) / 2;
        
        auto r1 = count(2 * node + 1, nl, mi);
        auto r2 = count(2 * node + 2, mi, nr);

        vector<pair<int, int>> res;
        res.reserve(SZ(r1) + SZ(r2));
        
        int p1 = 0, p2 = 0;
        while (p1 != SZ(r1) and p2 != SZ(r2)) {
            if (r1[p1].first < r2[p2].first)
                res.emplace_back(r1[p1].first, r1[p1].second + r2[0].second), ++p1;
            else if (r1[p1].first == r2[p2].first)
                res.emplace_back(r1[p1].first, r1[p1].second + r2[p2].second), ++p1, ++p2;
            else
                res.emplace_back(r2[p2].first, r1[0].second + r2[p2].second), ++p2;
        }

        while (p1 != SZ(r1))
            res.emplace_back(r1[p1].first, r1[p1].second + r2[0].second), ++p1;

        while (p2 != SZ(r2))
            res.emplace_back(r2[p2].first, r1[0].second + r2[p2].second), ++p2;

        
        int wc = TYPEMAX(int);
        for (auto& c: res)
            wc = min(wc, 1 + c.second);

        for (auto& c: res)
            c.second = min(c.second, wc);
        
        return res;
    }
}

int main() {
    std::iostream::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    
    // code here.
    int k = input<int>();
    int n = input<int>();
    input<int>();

    STAMP("begin init");
    
    int low = 0;
    for (int i = 0; i != n; ++i) {
        int len = input<int>();
        int col = input<int>();

        init(0, 0, (1 << k), low, low + len, col);
        low += len;
    }

    STAMP("done init");
    auto tmp = count(0, 0, (1 << k));
    STAMP("done count");
    cout << tmp[0].second << "\n";

    STAMP("done print");
    
    return 0;
}
